/*

*/

import renderer.scene.*;
import renderer.pipeline.*;
import renderer.framebuffer.*;

/**

*/
public class Hw2_v1
{
   final static int WIDTH  = 800;
   final static int HEIGHT = 800;

   public static void main(String[] args)
   {
      // Turn on clipping in the rasterizer.
      Rasterize_Clip.doClipping = true;

      Scene scene = new Scene();

      scene.addModel( new P(), new N(), new W() );

      // Push the models away from where the camera is.
      for (Model m : scene.modelList)
      {
         for (int i = 0; i < m.vertexList.size(); ++i)
         {
            final Vertex v = m.vertexList.get(i);
            m.vertexList.set(i, new Vertex(v.x,
                                           v.y,
                                           v.z - 2));
         }
      }

      // Give each model an initial location.
      moveModel(scene.getModel(0), -1.6, 0); // P
      moveModel(scene.getModel(1), -0.5, 0); // N
      moveModel(scene.getModel(2),  0.6, 0); // W

      final FrameBuffer fb = new FrameBuffer(WIDTH, HEIGHT);

      // Create the frames of an animation.
      for (int i = 0; i < 450; ++i)
      {
         fb.clearFB();
         Pipeline.render(scene, fb.vp);
         fb.dumpFB2File(String.format("PPM_Hw2_v1_Frame%03d.ppm", i));
         updateScene(scene, i);
      }
   }


   private static void updateScene(Scene scene, int frameNumber)
   {

   }


   private static void moveModels(Scene scene, double deltaX, double deltaY)
   {

   }


   private static void moveModel(Model model, double deltaX, double deltaY)
   {

   }

}
