/*

*/

import renderer.scene.*;
import renderer.pipeline.*;
import renderer.framebuffer.*;

import java.awt.Color;
import java.util.LinkedList;

/**

*/
public class Hw2_v2
{
   final static int WIDTH  = 800;
   final static int HEIGHT = 800;
   final static int LENGTH = 30;

   public static void main(String[] args)
   {
      // Turn on clipping in the rasterizer.
      Rasterize_Clip.doClipping = true;

      Scene scene = new Scene();

      scene.addModel( new P(), new N(), new W() );

      // Push the models away from where the camera is.
      for (Model m : scene.modelList)
      {
         for (int i = 0; i < m.vertexList.size(); ++i)
         {
            final Vertex v = m.vertexList.get(i);
            m.vertexList.set(i, new Vertex(v.x,
                                           v.y,
                                           v.z - 2));
         }
      }

      // Give each model an initial location.
      moveModel(scene.getModel(0), -1.6, 0); // P
      moveModel(scene.getModel(1), -0.5, 0); // N
      moveModel(scene.getModel(2),  0.6, 0); // W

      // Create an empty List of FrameBuffers.
      final LinkedList<FrameBuffer> fbList = new LinkedList<>();

      // Initialize the list of FrameBuffers and create the initial segment of frames.
      for (int i = 0; i < LENGTH; ++i)
      {
         // create a new FrameBuffer


         // render the current Scene into the new FrameBuffer


         // add the new FrameBuffer at the front to the list


         // save a post processed frame
         postProcess(fbList).dumpFB2File(String.format("PPM_Hw2_v2_Frame%03d.ppm", i));

         // update the Scene
         updateScene(scene, i);
      }

      // Now cycle through the list of FrameBuffers, keeping its length constant.
      for (int i = LENGTH; i <= 450; ++i)
      {
         // remove the oldest FrameBuffer from the tail of the list


         // render the current Scene into the recycled FrameBuffer


         // add the recycled FrameBuffer at the front of the list


         // save a post processed frame
         postProcess(fbList).dumpFB2File(String.format("PPM_Hw2_v2_Frame%03d.ppm", i));

         // update the Scene
         updateScene(scene, i);
      }

      // Empty out the list and create the last segment of frames.
      for (int i = 451; i < 450 + LENGTH; ++i)
      {
         // remove the oldest FrameBuffer from the list


         // save a post processed frame
         postProcess(fbList).dumpFB2File(String.format("PPM_Hw2_v2_Frame%03d.ppm", i));
      }
   }


   private static void updateScene(Scene scene, int frameNumber)
   {

   }


   private static void moveModels(Scene scene, double deltaX, double deltaY)
   {

   }


   private static void moveModel(Model model, double deltaX, double deltaY)
   {

   }


   /**
      Use the List of FrameBuffer objects to compute, and return,
      a new FrameBuffer object.
   */
   private static FrameBuffer postProcess(final LinkedList<FrameBuffer> fbList)
   {
      final FrameBuffer resultFB = new FrameBuffer(WIDTH, HEIGHT);

      // Iterate through the list of source framebuffers and copy
      // every white pixel from a source framebuffer into resultFB,
      // but reduce the brightness of the white pixel by an amount
      // proportional to how "old" the source frame is. Don't let any
      // "older" pixel overwrite a "newer" pixel already in resultFB.

      return resultFB;
   }

}
